=== debian/changelog ===
pyopencl (2025.1-1) unstable; urgency=medium

  * New upstream release.  (Closes: #1083134)
  * Refresh patches.
  * Switch B-D from python3-pybind11 to python3-nanobind.
  * Switch B-D from python3-setuptools to python3-scikit-build-core and cmake.
  * Upstream changed buildsystem backend to scikit-build-core.
  * Update dependency on pytools to 2024.1.5.
  * Update Standards-Version to 4.7.2; no changes necessary.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 14 Apr 2025 12:07:22 +0200
