=== debian/control ===
Source: pyopencl
Section: python
Priority: optional
Maintainer: Debian OpenCL Maintainers <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders:
 Tomasz Rybak <serpent@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-numpy3,
 dh-sequence-python3,
 cmake,
 ocl-icd-opencl-dev | opencl-dev,
 opencl-c-headers,
 pybuild-plugin-pyproject,
 python3-all-dev,
 python3-nanobind,
 python3-scikit-build-core,
# only for running the tests
 pocl-opencl-icd [amd64 arm64 armel armhf i386 hurd-i386] <!nocheck> | mesa-opencl-icd <!nocheck>,
 python3-mako <!nocheck>,
 python3-pytest (>= 7) <!nocheck>,
 python3-pytools (>= 2024.1.5) <!nocheck>,
Build-Depends-Indep:
 dh-sequence-sphinxdoc <!nodoc>,
 python-mako-doc <!nodoc>,
 python3-doc <!nodoc>,
 python3-sphinx <!nodoc>,
 python3-sphinx-copybutton <!nodoc>,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://mathema.tician.de/software/pyopencl
Vcs-Git: https://salsa.debian.org/opencl-team/python-pyopencl.git
Vcs-Browser: https://salsa.debian.org/opencl-team/python-pyopencl

Package: python3-pyopencl
Architecture: any
Multi-Arch: no
Depends:
 ocl-icd-libopencl1 | libopencl1,
 pocl-opencl-icd | mesa-opencl-icd | opencl-icd,
 python3-mako,
 python3-numpy,
 python3-pytools (>= 2024.1.5),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 python-pyopencl-doc <!nodoc>,
Suggests:
 python3-pil.imagetk,
 python3-matplotlib,
 python3-opengl,
 python3-pytest,
Description: Python 3 module to access OpenCL parallel computation API
 PyOpenCL lets you access the OpenCL parallel computation API from
 Python. Here's what sets PyOpenCL apart:
  * Object cleanup tied to lifetime of objects. This idiom, often called
    RAII in C++, makes it much easier to write correct, leak- and
    crash-free code.
  * Completeness. PyOpenCL puts the full power of OpenCL’s API at your
    disposal, if you wish.
  * Convenience. While PyOpenCL's primary focus is to make all of OpenCL
    accessible, it tries hard to make your life less complicated as it
    does so--without taking any shortcuts.
  * Automatic Error Checking. All OpenCL errors are automatically
    translated into Python exceptions.
  * Speed. PyOpenCL’s base layer is written in C++, so all the niceties
    above are virtually free.
  * Helpful, complete documentation and a wiki.
  * Liberal licensing (MIT).
 .
 This package contains Python 3 modules.

Package: python-pyopencl-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Recommends:
 python-mako-doc,
 python3-doc,
Suggests:
 python3-pyopencl,
Description: module to access OpenCL parallel computation API (documentation)
 PyOpenCL lets you access the OpenCL parallel computation API from
 Python. Here's what sets PyOpenCL apart:
  * Object cleanup tied to lifetime of objects. This idiom, often called
    RAII in C++, makes it much easier to write correct, leak- and
    crash-free code.
  * Completeness. PyOpenCL puts the full power of OpenCL’s API at your
    disposal, if you wish.
  * Convenience. While PyOpenCL's primary focus is to make all of OpenCL
    accessible, it tries hard to make your life less complicated as it
    does so--without taking any shortcuts.
  * Automatic Error Checking. All OpenCL errors are automatically
    translated into Python exceptions.
  * Speed. PyOpenCL’s base layer is written in C++, so all the niceties
    above are virtually free.
  * Helpful, complete documentation and a wiki.
  * Liberal licensing (MIT).
 .
 This package contains HTML documentation and example scripts.
